package ru.ulstu.fc.rule.controller;

import jakarta.validation.Valid;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.ulstu.fc.rule.model.FuzzyRule;
import ru.ulstu.fc.rule.model.FuzzyRuleForm;
import ru.ulstu.fc.rule.service.FuzzyRuleService;

@RestController
@RequestMapping("fuzzyRuleRest")
public class FuzzyRuleRestController {
    private final FuzzyRuleService ruleService;

    public FuzzyRuleRestController(FuzzyRuleService ruleService) {
        this.ruleService = ruleService;
    }

    @GetMapping("/get/{projectId}/{ruleId}")
    public FuzzyRule get(@PathVariable(value = "projectId") Integer projectId,
                         @PathVariable(value = "ruleId") Integer id) {
        return ruleService.getById(id);
    }

    @PostMapping
    public FuzzyRule save(@Valid FuzzyRuleForm fuzzyRuleForm) {
        return ruleService.save(fuzzyRuleForm);
    }

    @DeleteMapping
    public void delete(@Valid FuzzyRuleForm fuzzyRuleForm) {
        if (fuzzyRuleForm != null && fuzzyRuleForm.getId() != null) {
            ruleService.delete(fuzzyRuleForm);
        }
    }
}
